#!/usr/local/bin/perl
#original handel_mail.pl Written by Shawn Scott 11/19/2003
#Version 1.0
#This script handles mail sent to the ipanalyze e-mail address.
#
## too many updates to mention
# v3.0 - Jeremy Kister 20050726

use lib ('/export/web/ipanalyze.example.com/data/lib');

use strict;
use DBI;
use Net::SMTP;
use IPAnalyze::Customers;

my %cfg;
open(CONFIG, '/export/web/ipanalyze.example.com/data/ipanalyze.conf') || die "cannot open ipanalyze.conf: $!\n";
while(<CONFIG>){
   s/^(.*)\s*#.*/$1/;
   next if(/^$/);
   chomp;
   if(/^(\S+)\s*=>\s?(.+)/){
      $cfg{$1} = $2;
   }
}
close CONFIG;

my ($netid,$msg);
my $n=0;
while((defined($_=<>)) && ($n < 200)){   
	if (/^X-NETID:\s*(\d+)/){   
		$netid = $1;
	}
	$msg .= $_;
	$n++;
}   

if(($ENV{'SENDER'} eq "") && defined($netid)){
	my $d_dbh = DBI->connect($cfg{d_dsn}, $cfg{d_dbun}, $cfg{d_dbpw}, {RaiseError => 1});
	my $c_dbh = $d_dbh;
	if($cfg{c_dsn} && $cfg{c_dbun} && $cfg{c_dbpw}){
		unless(($cfg{d_dsn} eq $cfg{c_dsn}) && ($cfg{d_dbun} eq $cfg{c_dbun}) && ($cfg{d_dbpw} eq $cfg{c_dbpw})){
			$c_dbh = DBI->connect ($cfg{c_dsn}, $cfg{c_dbun}, $cfg{c_dbpw}, {RaiseError => 1});
		}
	}
	my $customers = IPAnalyze::Customers->new();

	my $sql = 'SELECT status,notes FROM data WHERE netid = ' . $d_dbh->quote($netid);
	my $sth = $d_dbh->prepare($sql);
	$sth->execute;
	my $row = $sth->fetchrow_arrayref;
	my $old_status = $row->[0];

	my $db_notes = $row->[1];
	my $ts = localtime;
	$sql = 'UPDATE data SET';
	if($old_status eq '4'){
		# dont touch either
		warn "detected old_status was Holding";
	}elsif($old_status eq '6'){
		# not touching ostatus
		warn "detected old_stats was Hold Pending\n";
		$sql .= ' status = 4,';
	}else{
		$old_status--; # because IPAnalyze thought we were moving forward, but the email bounced.
		$sql .= ' status = 4, ostatus = ' . $d_dbh->quote($old_status) . ',';
	}
	my $newnotes = "${db_notes}\n${ts}: Administrative Message ---\n${msg}";
	$sql .= ' warn_level = 1, notes = ';
	$sql .= $d_dbh->quote($newnotes) . ' WHERE netid = ' . $d_dbh->quote($netid);
	$sth = $d_dbh->prepare($sql);
	$sth->execute;
	my $email_msg = "$cfg{home_dir}/data/templates/ipanalyze/text/request_bounce.txt";

	my $stuff = 'circuit_id,local_contact,local_email,tech_name,tech_email,tech_phone,cust_id';
	$sql = "SELECT $stuff FROM data WHERE netid = " . $d_dbh->quote($netid);
	$sth = $d_dbh->prepare($sql);
	$sth->execute;
	$row = $sth->fetchrow_arrayref;
	my $circuit_id = $row->[0];
	my $local_contact = $row->[1];
	my $local_email = $row->[2];
	my $tech_name = $row->[3];
	my $tech_email = $row->[4];
	my $tech_phone = $row->[5];
	my $cust_id = $row->[6];

	my $company_name = $customers->name($c_dbh,$d_dbh,'cust_id',$cust_id);

	my $smtp = Net::SMTP->new($cfg{mailhost});
	$smtp->mail($cfg{from});
	$smtp->recipient($local_email);
	$smtp->data();
	chop(my $date=`date`);
	$smtp->datasend("To: \"$local_contact\" <$local_email>\n");
	$smtp->datasend("From: \"IPAnalyze\" <$cfg{from}>\n");
	$smtp->datasend("Subject: IP Request Administrative Message for $netid\n");
	$smtp->datasend("Date: $date\n");
	$smtp->datasend("\n");
	$smtp->datasend("Hello ${local_contact},\n\n");
	open(EMAIL, $email_msg) || die "ERROR::Cannot open $email_msg::$!";
	while(<EMAIL>){
		$smtp->datasend($_);
	}
	close EMAIL;
	$smtp->datasend("Company Name: ${company_name}\n");
	$smtp->datasend("Customer ID: ${cust_id}\n");
	$smtp->datasend("Circuit ID: ${circuit_id}\n");
	$smtp->datasend("Technical Contact Name: ${tech_name}\n");
	$smtp->datasend("Technical Contact Phone: ${tech_phone}\n");
	$smtp->datasend("Technical Email (INVALID): ${tech_email}\n");
	$smtp->datasend("NetID: ${netid}\n\n");
	$smtp->dataend();
	$smtp->quit;
}else{  
	# run the next command in the .qmail file 
	exit;  
}
