#!/usr/local/bin/perl

# deletes requests sitting in revoked after 60 days

use lib ('/export/web/ipanalyze.example.com/data/lib');

use strict;
use DBI;
use IPAnalyze::Misc;
use IPAnalyze::IPmath;
use Sys::Hostname;

my $hostname = hostname();

my %cfg;
open(CONFIG, '/export/web/ipanalyze.example.com/data/ipanalyze.conf') || die "cannot open ipanalyze.conf: $!\n";
while(<CONFIG>){
   s/^(.*)\s*#.*/$1/;
   next if(/^$/);
   chomp;
   if(/^(\S+)\s*=>\s?(.+)/){
      $cfg{$1} = $2;
   }
}
close CONFIG;

my $misc = IPAnalyze::Misc->new();
my $ipmath = IPAnalyze::IPmath->new();

my $dbh = DBI->connect($cfg{d_dsn}, $cfg{d_dbun}, $cfg{d_dbpw}, {RaiseError => 1});
my $radius = DBI->connect('DBI:mysql:host=mysql.example.com;database=isp', 'root', undef, {RaiseError => 1});

my $sql = 'DELETE FROM data WHERE status = 7 AND netblock IS NULL';
my $sth = $dbh->prepare($sql);
$sth->execute;

my $i = 0;
my $sqla = 'DELETE FROM data WHERE netid = ';
my $age = (time() - 5184000); # 60 days
$sql = 'SELECT netid,netblock,cidr FROM data WHERE status = 7 AND last_updated < ' . $dbh->quote($age);
$sth = $dbh->prepare($sql);
$sth->execute;
while(my $row = $sth->fetchrow_arrayref){

	my	$code = $misc->check_igp($ipmath,$cfg{'igp_host'},$cfg{'igp_community'},$row->[1],$row->[2],$cfg{'igp_ignore_netmask'});
	if($code){
		# not in igp
		$sqla .= ' OR netid = ' if($i);
		$sqla .= $dbh->quote($row->[0]);
		$i++;
	}else{
		warn "$row->[0] - $row->[1]/$row->[2] is in IGP, but IPAnalyze says it's REVOKED\n";

		# assume it's good and someoen forgot to assign it.
		#my $notes = $misc->get_notes($dbh,$row->[0]);
		#$notes .= "\n\nAssigned by AutoAssign (found route in IGP)";
		#my $sqlb = 'UPDATE data SET status = 0, notes = ' . $dbh->quote($notes);
		#$sqlb .= ' WHERE netid = ' . $dbh->quote($row->[0]);
		#my $sthb = $dbh->prepare($sqlb);
		#$sthb->execute;
	}
}
if($i){
	my $stha = $dbh->prepare($sqla);
	$stha->execute;
}
